import java.sql.*;
import java.util.Scanner;

public class EmployeeJDBC {

	Integer		employeeId;
	String		firstName;
	String		lastName;
	String		email;
	String		phone;
	Date		hireDate;
	String		jobId;
	Double		salary;
	Double		commissionPct;
	Integer		managerId;
	Integer		departmentId;

	String		url = "jdbc:oracle:thin:@cs.calstatela.edu:1521:orc";
	String		username = "cs422stu99";
	String		password = "1234";

  static
  {
    try
    {
      Class.forName( "oracle.jdbc.driver.OracleDriver" );
    }
    catch( ClassNotFoundException e )
    {
      e.printStackTrace();
    }
  }

  /**
   * Given an employee id, construct an EmployeeJDBC object by loading
   * the employee information from the database.
   */
  public EmployeeJDBC( Integer id ) throws Exception
  {
    load(id);
  }

  /**
   * Given an employee id, load the information about the employee from
   * the database.
   */
  public void load( Integer id ) throws Exception
  {
    employeeId = id;
    boolean found = true;

    Connection c = DriverManager.getConnection( url, username, password );
    String sql = "select * from employees where employee_id = ?";
    PreparedStatement pstmt = c.prepareStatement( sql );
    pstmt.setInt( 1, employeeId );
    ResultSet rs = pstmt.executeQuery();

    if( rs.next() )
    {
      firstName = rs.getString( "first_name" );
      lastName = rs.getString( "last_name" );
      email = rs.getString( "email" );
      phone = rs.getString( "phone_number" );
      hireDate = rs.getDate( "hire_date" );
      jobId = rs.getString( "job_id" );
      salary = rs.getDouble( "salary" );
      commissionPct = rs.getDouble( "commission_pct" );
      managerId = rs.getInt( "manager_id" );
      departmentId = rs.getInt( "department_id" );
    }
    else
    {
      found = false;
    }

    rs.close();
    pstmt.close();
    c.close();

    if( ! found )
    {
      System.err.println( "Cannot find employee #" + id );
      System.exit(1);
    }
  }

  /**
   * Reload the information about current employee from the database.
   */
  public void reload() throws Exception
  {
    load( employeeId );
  }

  public void changeJob() throws Exception
  {
    System.out.println( "Please enter the information of the new job." );
    Scanner in = new Scanner( System.in );
    String line;

    String newPhone = phone;
    System.out.print( "phone (" + newPhone + "): " );
    if( ! (line = in.nextLine()).equals("") ) newPhone = line;

    String newJobId = jobId;
    System.out.print( "job id (" + newJobId + "): " );
    if( ! (line = in.nextLine()).equals("") ) newJobId = line;

    Double newSalary = salary;
    System.out.print( "salary (" + newSalary + "): " );
    if( ! (line = in.nextLine()).equals("") )
      newSalary = Double.parseDouble(line);

    Double newCommissionPct = commissionPct;
    System.out.print( "commission pecentage (" + newCommissionPct + "): " );
    if( ! (line = in.nextLine()).equals("") )
      newCommissionPct = Double.parseDouble(line);

    Integer newManagerId = managerId;
    System.out.print( "manager id (" + newManagerId + "): "); 
    if( ! (line = in.nextLine()).equals("") )
      newManagerId = Integer.parseInt(line);

    Integer newDepartmentId = departmentId;
    System.out.print( "department id (" + newDepartmentId + "): " );
    if( ! (line = in.nextLine()).equals("") )
      newDepartmentId = Integer.parseInt(line);

    System.out.println( newPhone );
    System.out.println( newJobId );
    System.out.println( newSalary );
    System.out.println( newCommissionPct );
    System.out.println( newManagerId );
    System.out.println( newDepartmentId );

    // add code here to implement the job change, and test your code with
    // at least the following three test cases:
    // 
    // employeeId  newJobId  newSalary  newManagerId  newDepartmentId
    // 103         AD_VP     20000      100           90
    // 122         FI_MGR    18000      101           100
    // 122         FI_MGR    12000      101           100
  }

  public String toString()
  {
    return "employee id: " + employeeId + "\n" +
           "first name: " + firstName + "\n" +
           "last name: " + lastName + "\n" +
           "emal: " + email + "\n" +
           "phone: " + phone + "\n" +
           "hire date: " + hireDate + "\n" +
           "job id: " + jobId + "\n" +
           "salary: " + salary + "\n" +
           "commision percentage: " + commissionPct + "\n" +
           "manager id: " + managerId + "\n" +
           "department id: " + departmentId + "\n";
  }

  public static void main( String args[] ) throws Exception
  {
    if( args.length != 1 )
    {
      System.err.println( "usage: java EmployeeJDBC <employeeId>" );
      System.exit(1);
    }

    EmployeeJDBC emp = new EmployeeJDBC( Integer.parseInt(args[0]) );
    System.out.println( emp );
    emp.changeJob();
    emp.reload();
    System.out.println( emp );
  }

} // end of class EmployeeJDBC

